<?php
require_once("eranet_class.php");

function eranet_getConfigArray() {
	$configarray = array(
	 "confUserID" => array( "Type" => "text", "Size" => "20", "Description" => "User ID", ),
	 "confAPIPassword" => array( "Type" => "password", "Size" => "20", "Description" => "Input Your API Password", ),
	 "confServer" => array( "Type" => "text", "Size" => "30", "Description" => "Default Server is api.eranet.com:2080", ),
	);
	return $configarray;
}
function eranet_GetNameservers($params) {
	$domainObj=new eranet_Domain($params);
    $domain=$params["sld"] . '.' . $params["tld"];
    $resp=$domainObj->orderid($domain);
    if(intval($resp)){
        $domain_id=$resp;
    }else{
        return ['error'=>$resp];
    }
    $resp=$domainObj->infoDomain($domain_id);
    $nsList=explode(";",$resp['ns']);
    foreach ($nsList as $key=> $ns){
        $values["ns".($key+1)]=$ns;
    }
    return $values;
}
function eranet_SaveNameservers($params) {
	$domainObj=new eranet_Domain($params);
	$domain = $params["sld"] . '.' . $params["tld"];
    $resp=$domainObj->orderid($domain);
    if(intval($resp)){
        $domain_id=$resp;
    }else{
        return ['error'=>$resp];
    }
    $nsList = array();
    if ($params["ns1"]) $nsList[] = $params["ns1"];
    if ($params["ns2"]) $nsList[] = $params["ns2"];
    if ($params["ns3"]) $nsList[] = $params["ns3"];
    if ($params["ns4"]) $nsList[] = $params["ns4"];
    $resp=$domainObj->modifyNs($domain_id,$nsList);
    if($resp!==true) {
        return ['error' => $resp];
    }
}

function test($_str,$country){
	$checknum= array('AO' => 244,'AF' => 93,'AL' => 355,'DZ' => 213,'AD' => 376,'AI' => 1264,'AG' => 1268,'AR' => 54,'AM' => 374,' ' => 247,'AU' => 61,'AT' => 43,'AZ' => 994,'BS' => 1242,'BH' => 973,'BD' => 880,'BB' => 1246,'BY' => 375,'BE' => 32,'BZ' => 501,'BJ' => 229,'BM' => 1441,'BO' => 591,'BW' => 267,'BR' => 55,'BN' => 673,'BG' => 359,'BF' => 226,'MM' => 95,'BI' => 257,'CM' => 237,'CA' => 1,' ' => 1345,'CF' => 236,'TD' => 235,'CL' => 56,'CN' => 86,'CO' => 57,'CG' => 242,'CK' => 682,'CR' => 506,'CU' => 53,'CY' => 357,'CZ' => 420,'DK' => 45,'DJ' => 253,'DO' => 1890,'EC' => 593,'EG' => 20,'SV' => 503,'EE' => 372,'ET' => 251,'FJ' => 679,'FI' => 358,'FR' => 33,'GF' => 594,'GA' => 241,'GM' => 220,'GE' => 995,'DE' => 49,'GH' => 233,'GI' => 350,'GR' => 30,'GD' => 1809,'GU' => 1671,'GT' => 502,'GN' => 224,'GY' => 592,'HT' => 509,'HN' => 504,'HK' => 852,'HU' => 36,'IS' => 354,'IN' => 91,'ID' => 62,'IR' => 98,'IQ' => 964,'IE' => 353,'IL' => 972,'IT' => 39,' ' => 225,'JM' => 1876,'JP' => 81,'JO' => 962,'KH' => 855,'KZ' => 327,'KE' => 254,'KR' => 82,'KW' => 965,'KG' => 331,'LA' => 856,'LV' => 371,'LB' => 961,'LS' => 266,'LR' => 231,'LY' => 218,'LI' => 423,'LT' => 370,'LU' => 352,'MO' => 853,'MG' => 261,'MW' => 265,'MY' => 60,'MV' => 960,'ML' => 223,'MT' => 356,' ' => 1670,' ' => 596,'MU' => 230,'MX' => 52,'MD' => 373,'MC' => 377,'MN' => 976,'MS' => 1664,'MA' => 212,'MZ' => 258,'NA' => 264,'NR' => 674,'NP' => 977,' ' => 599,'NL' => 31,'NZ' => 64,'NI' => 505,'NE' => 227,'NG' => 234,'KP' => 850,'NO' => 47,'OM' => 968,'PK' => 92,'PA' => 507,'PG' => 675,'PY' => 595,'PE' => 51,'PH' => 63,'PL' => 48,'PF' => 689,'PT' => 351,'PR' => 1787,'QA' => 974,' ' => 262,'RO' => 40,'RU' => 7,'LC' => 1758,'VC' => 1784,' ' => 684,' ' => 685,'SM' => 378,'ST' => 239,'SA' => 966,'SN' => 221,'SC' => 248,'SL' => 232,'SG' => 65,'SK' => 421,'SI' => 386,'SB' => 677,'SO' => 252,'ZA' => 27,'ES' => 34,'LK' => 94,'LC' => 1758,'VC' => 1784,'SD' => 249,'SR' => 597,'SZ' => 268,'SE' => 46,'CH' => 41,'SY' => 963,'TW' => 886,'TJ' => 992,'TZ' => 255,'TH' => 66,'TG' => 228,'TO' => 676,'TT' => 1809,'TN' => 216,'TR' => 90,'TM' => 993,'UG' => 256,'UA' => 380,'AE' => 971,'GB' => 44,'US' => 1,'UY' => 598,'UZ' => 233,'VE' => 58,'VN' => 84,'YE' => 967,'YU' => 381,'ZW' => 263,'ZR' => 243,'ZM' => 260);
    
    $_str = preg_replace("/\s|　/","",$_str);
    $_str = preg_replace("/^0+/","",$_str);
    $pre = $checknum[$country];
    if(preg_match('/^+/',$_str)&&preg_match('/\.|-/',$_str)){
		if(preg_match('/-/',$_str)){
			$_str = preg_replace("/-/",".",$_str);
		}
	
	}elseif(preg_match('/\.|-/',$_str)){

		$a =preg_split('/\.|-/', $_str);
		$_str = $a[1];
		
		if(!$pre){
			$pre = '+86.';
		}else{
			$pre = '+'.$pre.'.';
		}
	}else{
		$_str = preg_replace("/\+/","",$_str);
		if(!$pre){
			$pre = '+86.';
		}else{
			$pre = '+'.$pre.'.';
		}
	}
	return $pre.$_str;
}

function eranet_GetDNS($params){
    $domain = $params["sld"] . "." . $params["tld"];
    	$domainObj = new eranet_Domain($params);
     $resp=$domainObj->describeRecordIndex($domain);
      $hostrecords = array();
      foreach ($resp['Data'] as $item){
          $hostrecords[]=["recid"=>$item['id'],"hostname" => $item['host'], "type" => $item['type'], "address" => $item['value'], ];
      }
    
	return $hostrecords;
}
function eranet_SaveDNS($params){
  
     $domain = $params["sld"] . "." . $params["tld"];
     $dnsrecords = $params['dnsrecords'];
     	$domainObj = new eranet_Domain($params);
     foreach ($dnsrecords as $record){
           
         if($record['recid']&&$record['hostname']){
          $resp=   $domainObj->UpdateDomainRecord($record['recid'],$record['hostname'],$record['type'],$record['address'],"");
         }elseif($record['recid']&&!$record['hostname']){
           $resp=  $domainObj->DeleteDomainRecord($record['recid']);
         }else{
           $resp=  $domainObj->AddDomainRecord($domain,$record['hostname'],$record['type'],$record['address'],"");
         }
         
         
     }
    return ['success'=>'success'];
}

function eranet_RegisterDomain($params) {

    $phonenumber=$params["phonenumber"];
    $adminphonenumber=$params["adminphonenumber"];
	$params["phonenumber"] = test($params["phonenumber"],$params["country"]);
	$params["adminphonenumber"] = test($params["adminphonenumber"],$params["admincountry"]);
	$domainObj = new eranet_Domain($params);
	//创建注册联系人
    $contactI=[
        'name'=>"{$params["firstname"]} {$params["lastname"]}",
        'name-loc'=>"{$params["firstname"]} {$params["lastname"]}",
        'company'=>$params["companyname"],
        'company-loc'=>$params["companyname"],
        'email'=>$params["email"],
        'address-line-1'=>"{$params["address1"]} {$params["address2"]}",
        'address-loc-line-1'=>"{$params["address1"]} {$params["address2"]}",
        'city'=>$params["city"],
        'country'=>$params["country"],
        'zipcode'=>$params['postcode'],
        'mobile-cc'=>$params['phone-cc'],
        'mobile'=>$phonenumber,
        'phone-cc'=>$params['phone-cc'],
        'phone'=>$phonenumber,
        'address-line-2'=>'',
        'address-line-3'=>'',
        'state'=>$params["state"],
        'fax-cc'=>$params['phone-cc'],
        'fax'=>$phonenumber,
    ];
    $resp=$domainObj->createContact($contactI);
    if(intval($resp)){
        $reg_contact_id=$resp;
    }else{
        return ['error'=>'reg_contact : '.$resp];
    }
    $admin_contact_id=$reg_contact_id;
    $resp = $domainObj->createDomain("{$params["sld"]}.{$params["tld"]}",
        $params["regperiod"],
        [$params["ns1"], $params["ns2"]],
        $reg_contact_id,
        $admin_contact_id
    );
    if(is_string($resp)){
        return ['error' => $resp];
    }
}

function eranet_RenewDomain($params) {
    $domainObj = new eranet_Domain($params);

    $domain = $params["sld"] . "." . $params["tld"];
	$result = select_query( "tbldomains", "expirydate", array( "id" => $params["domainid"] ) );
	$data = mysql_fetch_array( $result );

    $resp=$domainObj->orderid($domain);
    if(intval($resp)){
        $domain_id=$resp;
    }else{
        return ['error'=>$resp];
    }
    $domainI=[
        'domain_id'=>$domain_id,
        'domainperiod'=>$params["regperiod"],
        'curexpired'=>$data["expirydate"],
    ];
    $resp=$domainObj->renewDomain($domainI);
    if($resp!==true)return ['error'=>$resp];
}


function eranet_TransferDomain($params){
    $phonenumber=$params["phonenumber"];
    $adminphonenumber=$params["adminphonenumber"];
    $params["phonenumber"] = test($params["phonenumber"],$params["country"]);
    $params["adminphonenumber"] = test($params["adminphonenumber"],$params["admincountry"]);
    $domainObj = new eranet_Domain($params);
    //创建注册联系人
    $contactI=[
        'name'=>"{$params["firstname"]} {$params["lastname"]}",
        'name-loc'=>"{$params["firstname"]} {$params["lastname"]}",
        'company'=>$params["companyname"],
        'company-loc'=>$params["companyname"],
        'email'=>$params["email"],
        'address-line-1'=>"{$params["address1"]} {$params["address2"]}",
        'address-loc-line-1'=>"{$params["address1"]} {$params["address2"]}",
        'city'=>$params["city"],
        'country'=>$params["country"],
        'zipcode'=>$params['postcode'],
        'mobile-cc'=>$params['phone-cc'],
        'mobile'=>$phonenumber,
        'phone-cc'=>$params['phone-cc'],
        'phone'=>$phonenumber,
        'address-line-2'=>'',
        'address-line-3'=>'',
        'state'=>$params["state"],
        'fax-cc'=>$params['phone-cc'],
        'fax'=>$phonenumber,
    ];
    $resp=$domainObj->createContact($contactI);
    if(intval($resp)){
        $reg_contact_id=$resp;
    }else{
        return ['error'=>'reg_contact : '.$resp];
    }
    $admin_contact_id=$reg_contact_id;
    $resp=$domainObj->transferDomain("{$params["sld"]}.{$params["tld"]}",
        $params['eppcode'],
        $reg_contact_id,
        $admin_contact_id);
    if($resp!==true)return ['error'=>$resp];
}